



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>如何解决WebService参数传递中文乱码问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">如何解决WebService参数传递中文乱码问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 21:31:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1，问题由来</h3>
<p>我的主要工作是负责统一适配平台这块，主要任务是提供给客户统一的调用接口，客户使用这个接口可以通过我们再调不同厂家的接口。主要流程如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799561/201512/799561-20151229115031792-2104623812.png"></p>
<p>现在客户那边传来的请求报文里面包含中文，使用webservice发送一般是用UTF-8，但是客户那边传来的请求的格式肯定不是的，不然也不会出现中文乱码：<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799561/201512/799561-20151229115033010-1171730703.png"></p>
<h3>2，解决之法</h3>
<p>在北向处理的流程中，在接收到客户传来的报文的时候进行编码转换。加上下面两个方法，在得到客户请求报文时只需调用第一个方法转换一下即可。</p>
<div>
<pre class="prettyprint linenums">    //中文字符处理<br />
    public String charSetConvert(String xmlRequest){<br />
        String charSet = NeopServerImpl.getEncoding(xmlRequest);<br />
        try {<br />
            byte[] b = xmlRequest.getBytes(charSet);<br />
            xmlRequest = new String(b, "UTF-8");<br />
        } catch (Exception e) {<br />
            logger.error("输入的内容不属于常见的编码格式,请再仔细核实", e);<br />
        }<br />
        return xmlRequest;

    }<br />
    public static String getEncoding(String str) {<br />
        String encode = "GB2312";<br />
        try {<br />
            if (str.equals(new String(str.getBytes(encode), encode))) { // 判断是不是GB2312<br />
                String s = encode;<br />
                return s; // 是的话，返回GB2312，以下代码同理<br />
            }<br />
        } catch (Exception e) {<br />
            logger.error("getEncoding异常---GB2312", e);<br />
        }<br />
        encode = "ISO-8859-1";<br />
        try {<br />
            if (str.equals(new String(str.getBytes(encode), encode))) { // 判断是不是ISO-8859-1<br />
                String s1 = encode;<br />
                return s1;<br />
            }<br />
        } catch (Exception e) {<br />
            logger.error("getEncoding异常---ISO-8859-1", e);<br />
        }<br />
        encode = "UTF-8";<br />
        try {<br />
            if (str.equals(new String(str.getBytes(encode), encode))) { // 判断是不是UTF-8编码<br />
                String s2 = encode;<br />
                return s2;<br />
            }<br />
        } catch (Exception e) {<br />
            logger.error("getEncoding异常---UTF-8", e);<br />
        }<br />
        encode = "GBK";<br />
        try {<br />
            if (str.equals(new String(str.getBytes(encode), encode))) { // 判断是不是GBK<br />
                String s3 = encode;<br />
                return s3;<br />
            }<br />
        } catch (Exception e) {<br />
            logger.error("getEncoding异常---GBK", e);<br />
        }<br />
        return ""; // 到这一步，你就应该检查是不是其他编码啦</pre>
<pre class="prettyprint linenums">    }</pre>
</div>
<p>注：以上部分代码参考网上资源：<a href="http://zhidao.baidu.com/link?url=gXafoS7hIAKe8lcuUldTW9sQWa3C3VnLLbfid09lY2WYO8ypuM0yc5BFGKFY5vaPuaJBLi4Qkr5cDBe0_eWE0_" rel="external nofollow noreferrer">http://zhidao.baidu.com/link?url=gXafoS7hIAKe8lcuUldTW9sQWa3C3VnLLbfid09lY2WYO8ypuM0yc5BFGKFY5vaPuaJBLi4Qkr5cDBe0_eWE0_</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r412d8.html">word20161209</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7n06x9.html">python【6】-函数式编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k44w39.html">当spring 容器初始化完成后执行某个方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxr520q.html">分享一个c&num;t的网页抓取类</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r37ye9.html">【android-tips】如何在view中取得activity对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96xvdj9.html">Oracle DBA从小白到入职实战应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xppz09.html">&lbrack;my&rsqb;&lowbar;ubuntu12&period;10&lowbar;&sol;etc&sol;apt&sol;sources&period;list</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnyy608.html">快速建立Linux c&sol;c&plus;&plus;编译环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dx6j9.html">Android Studio安装使用图文教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13wg79.html">RFID标签天线的三种制作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96po2m38.html">Android中canvas&period;save&lpar;&rpar;和canvas&period;restore&lpar;&rpar;的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljjmwk9.html">J2SE基础&colon;1&period;类和对象基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1oepxq.html">小技巧：selenium java中如何使用chrome默认的profile</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyp238.html">Android开发之Intent&period;Action 各种Action的常见作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljglex9.html">&lbrack;Abp 源码分析&rsqb;十四、DTO 自动验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpm41xq.html">pdb调试神器使用终极指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25m6koq.html">C&plus;&plus;模板的使用以及常见问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7og2jj8.html">Listener&lpar;1&rpar;&mdash;基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2o6rpq.html">JS 模块 p6</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppddjy9.html">Consul &plus; fabio 实现自动服务发现、负载均衡 - DockOne&period;io</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4d2e5q.html">运行Java cmd程序 找不到或无法加载主类怎么解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23edl9.html">ACM之路（20）&mdash;&mdash; Splay初探</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9372jw8.html">scrollview技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96dey48.html">sdk添加新的C文件编译出错</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q234gw9.html">&lbrack;OC笔记&rsqb;我的第一个OC程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7x6m8.html">无法更新 EntitySet&OpenCurlyDoubleQuote;SoreInfo&lowbar;Table&rdquo;，因为它有一个 DefiningQuery，而 &amp;lt&semi;ModificationFunctionMapping&amp;gt&semi; 元素中没有支持当前操作的 &amp;lt&semi;InsertFunction&amp;gt&semi; 元素。</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96dv6j8.html">CSS基础选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7egd8.html">yum安装出错</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnw72kq.html">C&num; Winform学习--- 实现石头剪刀布的游戏</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ewnzz8.html">支付宝App支付签名和验签</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
